package com.bug;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.Key;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.UnrecoverableEntryException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Collections;

import javax.xml.crypto.MarshalException;
import javax.xml.crypto.dsig.XMLSignatureException;

import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.openxml4j.opc.OPCPackage;
import org.apache.poi.poifs.crypt.dsig.SignatureConfig;
import org.apache.poi.poifs.crypt.dsig.SignatureInfo;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class SheetDeleteionAndSigning {

	public static void main(String[] args) {
//		working();
		notWorking();
	}
	
	private static void working() {
		doWork(2, "working.xlsx");
	}
	
	private static void notWorking() {
		doWork(0, "notworking.xlsx");
	}
	
	private static void doWork(int sheetToDelete, String resultFileName){
		try {
			System.out.println("START");
			Workbook wb = getWorkbook();
			wb.removeSheetAt(sheetToDelete);
			byte[] data = getBytes(wb);
			data = signDocument_unsafe(data, new File("./resources/testkeystore.jks"), "JKS", "abcdef", "test");
			FileOutputStream fos = new FileOutputStream("./resources/" + resultFileName);
			fos.write(data);
			fos.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			System.out.println("END");
		}
	}
	
	private static Workbook getWorkbook() throws Exception {
		SXSSFWorkbook wb = new SXSSFWorkbook((XSSFWorkbook)WorkbookFactory.create(new File("./resources/template.xlsx")), 10);
		wb.setCompressTempFiles(true);
		return wb;
	}
	
	private static byte[] getBytes(Workbook workbook) throws IOException {
		ByteArrayOutputStream os = null;
		try {
			os = new ByteArrayOutputStream();
			workbook.write(os);
			byte[] bytes = os.toByteArray();
			return bytes;
		} finally {
			if (os != null) {
				os.close();
			}
		}
	}

	private static byte[] signDocument_unsafe(byte[] document, final File keyStoreFile, final String keystoreType, final String passwordString, final String alias)
			throws NoSuchAlgorithmException,
			CertificateException,
			KeyStoreException,
			InvalidFormatException,
			IOException,
			XMLSignatureException,
			MarshalException, UnrecoverableEntryException {
		final char[] password = passwordString.toCharArray();
		final KeyStore keystore = getKeystore(keyStoreFile, keystoreType, password);

		System.out.println(Collections.list(keystore.aliases()));
		
		// extracting private key and certificate
		Key key = keystore.getKey(alias, password);
		X509Certificate x509 = (X509Certificate) keystore.getCertificate(alias);

		// filling the SignatureConfig entries (minimum fields, more options are available ...)
		SignatureConfig signatureConfig = new SignatureConfig();
		signatureConfig.setKey((PrivateKey) key);
		signatureConfig.setSigningCertificateChain(Collections.singletonList(x509));

		// sign the XML
		OPCPackage pkg = OPCPackage
			.open(new ByteArrayInputStream(document)/* , PackageAccess.READ_WRITE */);
		try {
			signatureConfig.setOpcPackage(pkg);

			// adding the signature document to the package
			SignatureInfo si = new SignatureInfo();
			si.setSignatureConfig(signatureConfig);
			si.confirmSignature();
			// verify the generated signature
			if (!si.verifySignature()) {
				throw new RuntimeException("Unable to verify the signature we just generated");
			}

			// write the changes back to disc
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			pkg.save(bos);
			return bos.toByteArray();
		} finally {
			pkg.close();
		}
	}
	
	private static KeyStore getKeystore(final File keystoreFile, final String keystoreType, final char[] password)
			throws NoSuchAlgorithmException, CertificateException, KeyStoreException, IOException {
		KeyStore keystore = KeyStore.getInstance(keystoreType);
		
		InputStream in = null;
		try {
			in = new BufferedInputStream(new FileInputStream(keystoreFile));
			keystore.load(in, password);
			return keystore;
		} finally {
			if (in != null) {
				try {
					in.close();
				} catch (IOException ignore) {
				}
			}
		}
	}
	
}
